package it.integry.integrywmsnative.gest.prod_accettazione_ord_produzione.filters;

import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.databinding.DataBindingUtil;
import androidx.lifecycle.MutableLiveData;

import com.annimon.stream.ComparatorCompat;
import com.annimon.stream.Stream;
import com.ravikoradiya.liveadapter.LiveAdapter;

import java.util.ArrayList;
import java.util.List;
import java.util.Locale;
import java.util.Objects;

import it.integry.integrywmsnative.BR;
import it.integry.integrywmsnative.R;
import it.integry.integrywmsnative.core.di.BindableBoolean;
import it.integry.integrywmsnative.core.expansion.RunnableArgs;
import it.integry.integrywmsnative.core.model.JtbComt;
import it.integry.integrywmsnative.core.utility.UtilityBoolean;
import it.integry.integrywmsnative.databinding.LayoutFilterCommessaBinding;
import it.integry.integrywmsnative.ui.filter_chips.FilterLayoutView;

public class FilterCommessaLayoutView extends FilterLayoutView {

    protected LayoutFilterCommessaBinding mBindings;

    private List<JtbComt> allCommesse;
    private List<JtbComt> availableCommesse;
    private List<JtbComt> preSelectedCommesse = new ArrayList<>();
    private List<JtbComt> hiddenCommesse = new ArrayList<>();
    private final MutableLiveData<List<ListModel>> listModel = new MutableLiveData<>();

    private RunnableArgs<List<JtbComt>> onFilterApplied;

    @Nullable
    @Override
    public View onCreateView(@NonNull LayoutInflater inflater, @Nullable ViewGroup container, @Nullable Bundle savedInstanceState) {
        mBindings = DataBindingUtil.inflate(inflater, R.layout.layout_filter_commessa, container, false);
        this.mBindings.setView(this);

        refreshList();

        this.setSearchView(this.mBindings.searchView, newFilter -> {
            hiddenCommesse = Stream.of(allCommesse)
                    .filter(x -> !x.getCodJcom().toUpperCase(Locale.ROOT).contains(newFilter.toUpperCase(Locale.ROOT)) &&
                            !x.getDescrizione().toUpperCase(Locale.ROOT).contains(newFilter.toUpperCase(Locale.ROOT)))
                    .toList();

            refreshList();
        });


        new LiveAdapter(listModel, getViewLifecycleOwner(), BR.item)
                .map(ListModel.class, R.layout.layout_filter_commessa__list_item)
                .into(this.mBindings.recyclerview);

        return mBindings.getRoot();
    }

    private void refreshList() {
        ComparatorCompat<ListModel> c =
                ComparatorCompat
                        .chain(new ComparatorCompat<ListModel>((x, y) -> UtilityBoolean.toInt(x.getSelected().get()) - UtilityBoolean.toInt(y.getSelected().get())))
                        .thenComparing(new ComparatorCompat<>((x, y) -> UtilityBoolean.toInt(x.getEnabled().get()) - UtilityBoolean.toInt(y.getEnabled().get())))
                        .thenComparing(new ComparatorCompat<>((x, y) -> y.getOriginalModel().getCodJcom().compareTo(x.getOriginalModel().getCodJcom())))
                        .reversed();

        listModel.setValue(Stream.of(getAllCommesse())
                .filter(x -> !hiddenCommesse.contains(x))
                .map(x -> {
                    var selectedBoolean = new BindableBoolean(preSelectedCommesse.contains(x));
                    selectedBoolean.addOnPropertyChangedCallback(() -> {
                        if (selectedBoolean.get()) preSelectedCommesse.add(x);
                        else preSelectedCommesse.remove(x);
                    });

                    return new ListModel()
                            .setSelected(selectedBoolean)
                            .setEnabled(new BindableBoolean(availableCommesse.contains(x)))
                            .setOriginalModel(x);
                })
                .sorted(c)
                .toList());
    }


    public void onConfirm() {
        if (onFilterApplied == null) return;

        this.onFilterApplied.run(Stream.of(Objects.requireNonNull(listModel.getValue()))
                .filter(x -> x.selected.get())
                .map(x -> x.originalModel)
                .toList());

        dismiss();
    }

    public List<JtbComt> getAllCommesse() {
        return allCommesse;
    }

    public FilterCommessaLayoutView setAllCommesse(List<JtbComt> allCommesse) {
        this.allCommesse = allCommesse;
        return this;
    }

    public List<JtbComt> getAvailableCommesse() {
        return availableCommesse;
    }

    public FilterCommessaLayoutView setAvailableCommesse(List<JtbComt> availableCommesse) {
        this.availableCommesse = availableCommesse;
        return this;
    }

    public List<JtbComt> getPreSelectedCommesse() {
        return preSelectedCommesse;
    }

    public FilterCommessaLayoutView setPreSelectedCommesse(List<JtbComt> preSelectedCommesse) {
        this.preSelectedCommesse = preSelectedCommesse;
        return this;
    }

    public RunnableArgs<List<JtbComt>> getOnFilterApplied() {
        return onFilterApplied;
    }

    public FilterCommessaLayoutView setOnFilterApplied(RunnableArgs<List<JtbComt>> onFilterApplied) {
        this.onFilterApplied = onFilterApplied;
        return this;
    }

    public static class ListModel {
        private BindableBoolean selected = new BindableBoolean();
        private BindableBoolean enabled = new BindableBoolean();
        private JtbComt originalModel;

        public BindableBoolean getSelected() {
            return selected;
        }

        public ListModel setSelected(BindableBoolean selected) {
            this.selected = selected;
            return this;
        }

        public BindableBoolean getEnabled() {
            return enabled;
        }

        public ListModel setEnabled(BindableBoolean enabled) {
            this.enabled = enabled;
            return this;
        }

        public JtbComt getOriginalModel() {
            return originalModel;
        }

        public ListModel setOriginalModel(JtbComt originalModel) {
            this.originalModel = originalModel;
            return this;
        }
    }

}
